SystemOrganization addCategory: #'IRDA2013-Searching'!
SystemOrganization addCategory: #'IRDA2013-Searching-Tests'!

UserInterface subclass: #I2STaskUi
	instanceVariableNames: 'stack chapterOneButton taskDescription scrollArea chapterButton hintButton achievementButton solutionButton parameterDisplay codeEdit playButton stepButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

I2STaskUi subclass: #I2SActiveTaskUi
	instanceVariableNames: 'task'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SActiveTaskUi class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 16:25:47.67'!
newWithTask: aTask
	| ui |
	ui := self new.
	ui task: aTask.
	^ui! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 16:44:05.863'!
initialize
	super initialize.
	self initializePanel.
	
	"Workaround to prevent exceptions on mouseup UITextEdits"
	self taskDescription textMorph editor.
	self parameterDisplay textMorph editor.
	
	self stack currentIndex: 1.
	
	self connect: self hintButton signal: #pressed toSelector: #showHint.
	
	self connect: self chapterButton signal: #pressed toSelector: #showChapters.
	
	self connect: self playButton signal: #pressed toSelector: #runUserCode.
	
	self connect: self chapterOneButton signal: #pressed toSelector: #showChapterOne! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 13:03:31.221'!
resetVisualization: aVisualization
	| pos |
	
	self scrollArea transformMorph removeAllMorphs.
	self scrollArea transformMorph addMorph: aVisualization.
	pos := self scrollArea extent - aVisualization extent.
	pos := pos / 2.
	aVisualization position: (pos max: 0@0).! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 16:26:58.597'!
showChapterOne
	(self task isNil or: (self task class = I2SSearchTask) not) ifTrue: [
		self task: (I2SSearchTask
			newWithVisualizationClass: I2STreeSectionMorph
			andValue: 42
			andList: {50. 23. 57. 65. 45. 15. 86. 87. 19. 37. 46. 59. 36. 68. 45. 17. 12. 32. 53. 42}).
	].
	self stack currentIndex: 2.! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 16:20:29.542'!
showChapters
	self stack currentIndex:1.! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 14:06:46.862'!
showHint
	Transcript showln: 'HINT!!'.
	self taskDescription append: Character cr.
	self taskDescription append: Character lf.
	self taskDescription append: self task nextHint.
	self taskDescription textMorph editor.
	
	self taskDescription scrollToShow: (50000@50000 corner: 50001@50001).! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 16:26:27.189'!
task
	^task! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'dg 6/12/2013 15:25:00.508'!
task: aTask
	task := aTask.
	self taskDescription theText: self task description.
	self taskDescription textMorph editor.
	
	self parameterDisplay theText: task userCodeSignature.
	self codeEdit sourceCode: task userCode.
	
	self resetVisualization: task visualization.
	
	self
		connect: task
		signal: #visualization:
		toSelector: #resetVisualization:.
		
	self
		connect: task
		signal: #completed:
		toSelector: #taskComplete:.! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 15:58:11.838'!
taskComplete: aBoolean
	aBoolean ifTrue:[
		UserDialogBoxMorph new
			title: 'You WON!!';
			label: 'You WON!! You needed ',(self task clickCount asString),' clicks.';
			addSelectedCancelButton: '   YAY   ' translated
			value: nil;
			runModalIn: ActiveWorld forHand: ActiveHand at: nil.
	].! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/12/2013 16:31:09.6'!
achievementButton
	"No description given."
	
	^ achievementButton! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/12/2013 16:31:09.503'!
chapterButton
	"No description given."
	
	^ chapterButton! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/12/2013 16:31:09.374'!
chapterOneButton
	"No description given."
	
	^ chapterOneButton! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/12/2013 16:31:09.741'!
codeEdit
	"No description given."
	
	^ codeEdit! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/12/2013 16:31:09.545'!
hintButton
	"No description given."
	
	^ hintButton! !

!I2STaskUi methodsFor: 'ui - private' stamp: 'benjamin.siegmund 6/12/2013 16:31:09.927'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 unnamedMorph3 unnamedMorph4 unnamedMorph5 unnamedMorph6 unnamedMorph7 unnamedMorph8 unnamedMorph9 unnamedMorph10 unnamedMorph11 unnamedMorph12 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (624@513).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#leftToRight).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.925)).
	panel color: ((Color r: 0.884 g: 0.884 b: 0.884)).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	stack := UiStackedWidget new.
	stack changeTableLayout.
	stack extent: (616@505).
	stack position: (4@4).
	stack hResizing: (#spaceFill).
	stack vResizing: (#spaceFill).
	stack minWidth: (2).
	stack minHeight: (2).
	stack cellInset: (4).
	stack cellPositioning: (#center).
	stack cellSpacing: (#none).
	stack layoutInset: (0).
	stack listCentering: (#topLeft).
	stack listDirection: (#topToBottom).
	stack listSpacing: (#none).
	stack maxCellSize: (1073741823).
	stack minCellSize: (0).
	stack wrapCentering: (#topLeft).
	stack wrapDirection: (#none).
	stack frameFractions: (0@0 corner: 1@1).
	stack frameOffsets: (0@0 corner: 0@0).
	stack balloonText: (nil).
	stack balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	stack color: (Color transparent).
	stack borderWidth: (0).
	stack borderStyle2: (#simple).
	stack borderColor: (Color black).
	stack setProperty: #objectName toValue: 'stack'.
	unnamedMorph1 := UiWidgetPage new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (616@505).
	unnamedMorph1 position: (4@4).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#spaceFill).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (30).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (4).
	unnamedMorph1 listCentering: (#center).
	unnamedMorph1 listDirection: (#topToBottom).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#center).
	unnamedMorph1 wrapDirection: (#topToBottom).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.933)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	chapterOneButton := UiPushButton new.
	chapterOneButton changeTableLayout.
	chapterOneButton extent: (144@21).
	chapterOneButton position: (239@193).
	chapterOneButton hResizing: (#shrinkWrap).
	chapterOneButton vResizing: (#shrinkWrap).
	chapterOneButton minWidth: (2).
	chapterOneButton minHeight: (2).
	chapterOneButton cellInset: (4).
	chapterOneButton cellPositioning: (#center).
	chapterOneButton cellSpacing: (#none).
	chapterOneButton layoutInset: (2@0 corner: 2@0).
	chapterOneButton listCentering: (#topLeft).
	chapterOneButton listDirection: (#leftToRight).
	chapterOneButton listSpacing: (#none).
	chapterOneButton maxCellSize: (1073741823).
	chapterOneButton minCellSize: (0).
	chapterOneButton wrapCentering: (#topLeft).
	chapterOneButton wrapDirection: (#none).
	chapterOneButton frameFractions: (0@0 corner: 1@1).
	chapterOneButton frameOffsets: (0@0 corner: 0@0).
	chapterOneButton balloonText: (nil).
	chapterOneButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	chapterOneButton enabled: (true).
	chapterOneButton setProperty: #iconByDesigner toValue: 'nil'.
	chapterOneButton icon: (nil).
	chapterOneButton text: ('Chapter One: Searching').
	chapterOneButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	chapterOneButton checkable: (false).
	chapterOneButton checked: (false).
	chapterOneButton autoExclusive: (false).
	chapterOneButton setProperty: #objectName toValue: 'chapterOneButton'.
	unnamedMorph1 addChild: chapterOneButton.
	unnamedMorph2 := UiPushButton new.
	unnamedMorph2 changeTableLayout.
	unnamedMorph2 extent: (129@21).
	unnamedMorph2 position: (247@246).
	unnamedMorph2 hResizing: (#shrinkWrap).
	unnamedMorph2 vResizing: (#shrinkWrap).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (4).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (2@0 corner: 2@0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#leftToRight).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	unnamedMorph2 enabled: (true).
	unnamedMorph2 setProperty: #iconByDesigner toValue: 'nil'.
	unnamedMorph2 icon: (nil).
	unnamedMorph2 text: ('Chapter Two: Adding').
	unnamedMorph2 color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	unnamedMorph2 checkable: (false).
	unnamedMorph2 checked: (false).
	unnamedMorph2 autoExclusive: (false).
	unnamedMorph1 addChild: unnamedMorph2.
	unnamedMorph3 := UiPushButton new.
	unnamedMorph3 changeTableLayout.
	unnamedMorph3 extent: (151@21).
	unnamedMorph3 position: (236@299).
	unnamedMorph3 hResizing: (#shrinkWrap).
	unnamedMorph3 vResizing: (#shrinkWrap).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (4).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (2@0 corner: 2@0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#leftToRight).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	unnamedMorph3 enabled: (true).
	unnamedMorph3 setProperty: #iconByDesigner toValue: 'nil'.
	unnamedMorph3 icon: (nil).
	unnamedMorph3 text: ('Chapter Three: Balancing').
	unnamedMorph3 color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	unnamedMorph3 checkable: (false).
	unnamedMorph3 checked: (false).
	unnamedMorph3 autoExclusive: (false).
	unnamedMorph1 addChild: unnamedMorph3.
	stack addChild: unnamedMorph1.
	unnamedMorph4 := UiWidgetPage new.
	unnamedMorph4 changeTableLayout.
	unnamedMorph4 extent: (616@505).
	unnamedMorph4 position: (4@4).
	unnamedMorph4 hResizing: (#spaceFill).
	unnamedMorph4 vResizing: (#spaceFill).
	unnamedMorph4 minWidth: (2).
	unnamedMorph4 minHeight: (2).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (4).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#leftToRight).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	unnamedMorph5 := UiContainer new.
	unnamedMorph5 changeTableLayout.
	unnamedMorph5 extent: (364@497).
	unnamedMorph5 position: (8@8).
	unnamedMorph5 hResizing: (#spaceFill).
	unnamedMorph5 vResizing: (#spaceFill).
	unnamedMorph5 minWidth: (2).
	unnamedMorph5 minHeight: (2).
	unnamedMorph5 cellInset: (4).
	unnamedMorph5 cellPositioning: (#center).
	unnamedMorph5 cellSpacing: (#none).
	unnamedMorph5 layoutInset: (4).
	unnamedMorph5 listCentering: (#topLeft).
	unnamedMorph5 listDirection: (#topToBottom).
	unnamedMorph5 listSpacing: (#none).
	unnamedMorph5 maxCellSize: (1073741823).
	unnamedMorph5 minCellSize: (0).
	unnamedMorph5 wrapCentering: (#topLeft).
	unnamedMorph5 wrapDirection: (#none).
	unnamedMorph5 frameFractions: (0@0 corner: 1@1).
	unnamedMorph5 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph5 balloonText: (nil).
	unnamedMorph5 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.925)).
	unnamedMorph5 color: (Color transparent).
	unnamedMorph5 borderWidth: (0).
	unnamedMorph5 borderStyle2: (#simple).
	unnamedMorph5 borderColor: (Color black).
	taskDescription := UiTextEdit new.
	taskDescription extent: (356@70).
	taskDescription position: (12@13).
	taskDescription hResizing: (#spaceFill).
	taskDescription vResizing: (#rigid).
	taskDescription minWidth: (2).
	taskDescription minHeight: (2).
	taskDescription cellInset: (0).
	taskDescription cellPositioning: (#center).
	taskDescription cellSpacing: (#none).
	taskDescription layoutInset: (0).
	taskDescription listCentering: (#topLeft).
	taskDescription listDirection: (#topToBottom).
	taskDescription listSpacing: (#none).
	taskDescription maxCellSize: (1073741823).
	taskDescription minCellSize: (0).
	taskDescription wrapCentering: (#topLeft).
	taskDescription wrapDirection: (#none).
	taskDescription frameFractions: (0@0 corner: 1@1).
	taskDescription frameOffsets: (0@0 corner: 0@0).
	taskDescription balloonText: (nil).
	taskDescription balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	taskDescription widgetResizable: (true).
	taskDescription horizontalScrollBarPolicy: (#alwaysOff).
	taskDescription verticalScrollBarPolicy: (#alwaysOn).
	taskDescription outerBorderWidth: (1).
	taskDescription scrollBarThickness: (9).
	taskDescription theText: ('Task Description.').
	taskDescription readOnly: (true).
	taskDescription autoConvert: (false).
	taskDescription autoAccept: (false).
	taskDescription acceptOnFocusLost: (false).
	taskDescription scrollingMode: (#none).
	taskDescription scrollingLimit: (10).
	taskDescription setProperty: #objectName toValue: 'taskDescription'.
	unnamedMorph5 addChild: taskDescription.
	scrollArea := ViScrollArea new.
	scrollArea extent: (356@413).
	scrollArea position: (12@88).
	scrollArea hResizing: (#spaceFill).
	scrollArea vResizing: (#spaceFill).
	scrollArea minWidth: (2).
	scrollArea minHeight: (2).
	scrollArea cellInset: (0).
	scrollArea cellPositioning: (#center).
	scrollArea cellSpacing: (#none).
	scrollArea layoutInset: (0).
	scrollArea listCentering: (#topLeft).
	scrollArea listDirection: (#topToBottom).
	scrollArea listSpacing: (#none).
	scrollArea maxCellSize: (1073741823).
	scrollArea minCellSize: (0).
	scrollArea wrapCentering: (#topLeft).
	scrollArea wrapDirection: (#none).
	scrollArea frameFractions: (0@0 corner: 1@1).
	scrollArea frameOffsets: (0@0 corner: 0@0).
	scrollArea balloonText: (nil).
	scrollArea balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.925)).
	scrollArea widgetResizable: (false).
	scrollArea horizontalScrollBarPolicy: (#alwaysOn).
	scrollArea verticalScrollBarPolicy: (#alwaysOn).
	scrollArea outerBorderWidth: (0).
	scrollArea scrollBarThickness: (9).
	scrollArea setProperty: #objectName toValue: 'scrollArea'.
	unnamedMorph5 addChild: scrollArea.
	unnamedMorph4 addChild: unnamedMorph5.
	unnamedMorph6 := UiContainer new.
	unnamedMorph6 changeTableLayout.
	unnamedMorph6 extent: (240@497).
	unnamedMorph6 position: (376@8).
	unnamedMorph6 hResizing: (#rigid).
	unnamedMorph6 vResizing: (#spaceFill).
	unnamedMorph6 minWidth: (2).
	unnamedMorph6 minHeight: (2).
	unnamedMorph6 cellInset: (4).
	unnamedMorph6 cellPositioning: (#center).
	unnamedMorph6 cellSpacing: (#none).
	unnamedMorph6 layoutInset: (4).
	unnamedMorph6 listCentering: (#topLeft).
	unnamedMorph6 listDirection: (#topToBottom).
	unnamedMorph6 listSpacing: (#none).
	unnamedMorph6 maxCellSize: (1073741823).
	unnamedMorph6 minCellSize: (0).
	unnamedMorph6 wrapCentering: (#topLeft).
	unnamedMorph6 wrapDirection: (#none).
	unnamedMorph6 frameFractions: (0@0 corner: 1@1).
	unnamedMorph6 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph6 balloonText: (nil).
	unnamedMorph6 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	unnamedMorph6 color: (Color transparent).
	unnamedMorph6 borderWidth: (0).
	unnamedMorph6 borderStyle2: (#simple).
	unnamedMorph6 borderColor: (Color black).
	unnamedMorph7 := UiContainer new.
	unnamedMorph7 changeTableLayout.
	unnamedMorph7 extent: (230@71).
	unnamedMorph7 position: (381@12).
	unnamedMorph7 hResizing: (#shrinkWrap).
	unnamedMorph7 vResizing: (#shrinkWrap).
	unnamedMorph7 minWidth: (2).
	unnamedMorph7 minHeight: (2).
	unnamedMorph7 cellInset: (4).
	unnamedMorph7 cellPositioning: (#center).
	unnamedMorph7 cellSpacing: (#none).
	unnamedMorph7 layoutInset: (4).
	unnamedMorph7 listCentering: (#topLeft).
	unnamedMorph7 listDirection: (#leftToRight).
	unnamedMorph7 listSpacing: (#none).
	unnamedMorph7 maxCellSize: (1073741823).
	unnamedMorph7 minCellSize: (0).
	unnamedMorph7 wrapCentering: (#topLeft).
	unnamedMorph7 wrapDirection: (#none).
	unnamedMorph7 frameFractions: (0@0 corner: 1@1).
	unnamedMorph7 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph7 balloonText: (nil).
	unnamedMorph7 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.925)).
	unnamedMorph7 color: (Color transparent).
	unnamedMorph7 borderWidth: (0).
	unnamedMorph7 borderStyle2: (#simple).
	unnamedMorph7 borderColor: (Color black).
	unnamedMorph8 := UiContainer new.
	unnamedMorph8 changeTableLayout.
	unnamedMorph8 extent: (109@63).
	unnamedMorph8 position: (385@16).
	unnamedMorph8 hResizing: (#rigid).
	unnamedMorph8 vResizing: (#shrinkWrap).
	unnamedMorph8 minWidth: (2).
	unnamedMorph8 minHeight: (2).
	unnamedMorph8 cellInset: (4).
	unnamedMorph8 cellPositioning: (#center).
	unnamedMorph8 cellSpacing: (#none).
	unnamedMorph8 layoutInset: (4).
	unnamedMorph8 listCentering: (#topLeft).
	unnamedMorph8 listDirection: (#topToBottom).
	unnamedMorph8 listSpacing: (#none).
	unnamedMorph8 maxCellSize: (1073741823).
	unnamedMorph8 minCellSize: (0).
	unnamedMorph8 wrapCentering: (#topLeft).
	unnamedMorph8 wrapDirection: (#none).
	unnamedMorph8 frameFractions: (0@0 corner: 1@1).
	unnamedMorph8 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph8 balloonText: (nil).
	unnamedMorph8 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.925)).
	unnamedMorph8 color: (Color transparent).
	unnamedMorph8 borderWidth: (0).
	unnamedMorph8 borderStyle2: (#simple).
	unnamedMorph8 borderColor: (Color black).
	chapterButton := UiPushButton new.
	chapterButton changeTableLayout.
	chapterButton extent: (101@25).
	chapterButton position: (389@20).
	chapterButton hResizing: (#spaceFill).
	chapterButton vResizing: (#shrinkWrap).
	chapterButton minWidth: (2).
	chapterButton minHeight: (2).
	chapterButton cellInset: (4).
	chapterButton cellPositioning: (#center).
	chapterButton cellSpacing: (#none).
	chapterButton layoutInset: (2).
	chapterButton listCentering: (#center).
	chapterButton listDirection: (#leftToRight).
	chapterButton listSpacing: (#none).
	chapterButton maxCellSize: (1073741823).
	chapterButton minCellSize: (0).
	chapterButton wrapCentering: (#topLeft).
	chapterButton wrapDirection: (#none).
	chapterButton frameFractions: (0@0 corner: 1@1).
	chapterButton frameOffsets: (0@0 corner: 0@0).
	chapterButton balloonText: (nil).
	chapterButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	chapterButton enabled: (true).
	chapterButton setProperty: #iconByDesigner toValue: 'nil'.
	chapterButton icon: (nil).
	chapterButton text: ('Kapitel').
	chapterButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	chapterButton checkable: (false).
	chapterButton checked: (false).
	chapterButton autoExclusive: (false).
	chapterButton setProperty: #objectName toValue: 'chapterButton'.
	unnamedMorph8 addChild: chapterButton.
	hintButton := UiPushButton new.
	hintButton changeTableLayout.
	hintButton extent: (101@25).
	hintButton position: (389@49).
	hintButton hResizing: (#spaceFill).
	hintButton vResizing: (#shrinkWrap).
	hintButton minWidth: (2).
	hintButton minHeight: (2).
	hintButton cellInset: (4).
	hintButton cellPositioning: (#center).
	hintButton cellSpacing: (#none).
	hintButton layoutInset: (2).
	hintButton listCentering: (#center).
	hintButton listDirection: (#leftToRight).
	hintButton listSpacing: (#none).
	hintButton maxCellSize: (1073741823).
	hintButton minCellSize: (0).
	hintButton wrapCentering: (#topLeft).
	hintButton wrapDirection: (#none).
	hintButton frameFractions: (0@0 corner: 1@1).
	hintButton frameOffsets: (0@0 corner: 0@0).
	hintButton balloonText: (nil).
	hintButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	hintButton enabled: (true).
	hintButton setProperty: #iconByDesigner toValue: 'nil'.
	hintButton icon: (nil).
	hintButton text: ('Hint').
	hintButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	hintButton checkable: (false).
	hintButton checked: (false).
	hintButton autoExclusive: (false).
	hintButton setProperty: #objectName toValue: 'hintButton'.
	unnamedMorph8 addChild: hintButton.
	unnamedMorph7 addChild: unnamedMorph8.
	unnamedMorph9 := UiContainer new.
	unnamedMorph9 changeTableLayout.
	unnamedMorph9 extent: (109@63).
	unnamedMorph9 position: (498@16).
	unnamedMorph9 hResizing: (#rigid).
	unnamedMorph9 vResizing: (#shrinkWrap).
	unnamedMorph9 minWidth: (2).
	unnamedMorph9 minHeight: (2).
	unnamedMorph9 cellInset: (4).
	unnamedMorph9 cellPositioning: (#center).
	unnamedMorph9 cellSpacing: (#none).
	unnamedMorph9 layoutInset: (4).
	unnamedMorph9 listCentering: (#topLeft).
	unnamedMorph9 listDirection: (#topToBottom).
	unnamedMorph9 listSpacing: (#none).
	unnamedMorph9 maxCellSize: (1073741823).
	unnamedMorph9 minCellSize: (0).
	unnamedMorph9 wrapCentering: (#topLeft).
	unnamedMorph9 wrapDirection: (#none).
	unnamedMorph9 frameFractions: (0@0 corner: 1@1).
	unnamedMorph9 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph9 balloonText: (nil).
	unnamedMorph9 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.925)).
	unnamedMorph9 color: (Color transparent).
	unnamedMorph9 borderWidth: (0).
	unnamedMorph9 borderStyle2: (#simple).
	unnamedMorph9 borderColor: (Color black).
	achievementButton := UiPushButton new.
	achievementButton changeTableLayout.
	achievementButton extent: (101@25).
	achievementButton position: (502@20).
	achievementButton hResizing: (#spaceFill).
	achievementButton vResizing: (#shrinkWrap).
	achievementButton minWidth: (2).
	achievementButton minHeight: (2).
	achievementButton cellInset: (4).
	achievementButton cellPositioning: (#center).
	achievementButton cellSpacing: (#none).
	achievementButton layoutInset: (2).
	achievementButton listCentering: (#center).
	achievementButton listDirection: (#leftToRight).
	achievementButton listSpacing: (#none).
	achievementButton maxCellSize: (1073741823).
	achievementButton minCellSize: (0).
	achievementButton wrapCentering: (#topLeft).
	achievementButton wrapDirection: (#none).
	achievementButton frameFractions: (0@0 corner: 1@1).
	achievementButton frameOffsets: (0@0 corner: 0@0).
	achievementButton balloonText: (nil).
	achievementButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	achievementButton enabled: (true).
	achievementButton setProperty: #iconByDesigner toValue: 'nil'.
	achievementButton icon: (nil).
	achievementButton text: ('Achievements').
	achievementButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	achievementButton checkable: (false).
	achievementButton checked: (false).
	achievementButton autoExclusive: (false).
	achievementButton setProperty: #objectName toValue: 'achievementButton'.
	unnamedMorph9 addChild: achievementButton.
	solutionButton := UiPushButton new.
	solutionButton changeTableLayout.
	solutionButton extent: (101@25).
	solutionButton position: (502@49).
	solutionButton hResizing: (#spaceFill).
	solutionButton vResizing: (#shrinkWrap).
	solutionButton minWidth: (2).
	solutionButton minHeight: (2).
	solutionButton cellInset: (4).
	solutionButton cellPositioning: (#center).
	solutionButton cellSpacing: (#none).
	solutionButton layoutInset: (2).
	solutionButton listCentering: (#center).
	solutionButton listDirection: (#leftToRight).
	solutionButton listSpacing: (#none).
	solutionButton maxCellSize: (1073741823).
	solutionButton minCellSize: (0).
	solutionButton wrapCentering: (#topLeft).
	solutionButton wrapDirection: (#none).
	solutionButton frameFractions: (0@0 corner: 1@1).
	solutionButton frameOffsets: (0@0 corner: 0@0).
	solutionButton balloonText: (nil).
	solutionButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	solutionButton enabled: (true).
	solutionButton setProperty: #iconByDesigner toValue: 'nil'.
	solutionButton icon: (nil).
	solutionButton text: ('Solution').
	solutionButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	solutionButton checkable: (false).
	solutionButton checked: (false).
	solutionButton autoExclusive: (false).
	solutionButton setProperty: #objectName toValue: 'solutionButton'.
	unnamedMorph9 addChild: solutionButton.
	unnamedMorph7 addChild: unnamedMorph9.
	unnamedMorph6 addChild: unnamedMorph7.
	parameterDisplay := UiTextEdit new.
	parameterDisplay extent: (232@70).
	parameterDisplay position: (380@88).
	parameterDisplay hResizing: (#spaceFill).
	parameterDisplay vResizing: (#rigid).
	parameterDisplay minWidth: (2).
	parameterDisplay minHeight: (2).
	parameterDisplay cellInset: (0).
	parameterDisplay cellPositioning: (#center).
	parameterDisplay cellSpacing: (#none).
	parameterDisplay layoutInset: (0).
	parameterDisplay listCentering: (#topLeft).
	parameterDisplay listDirection: (#topToBottom).
	parameterDisplay listSpacing: (#none).
	parameterDisplay maxCellSize: (1073741823).
	parameterDisplay minCellSize: (0).
	parameterDisplay wrapCentering: (#topLeft).
	parameterDisplay wrapDirection: (#none).
	parameterDisplay frameFractions: (0@0 corner: 1@1).
	parameterDisplay frameOffsets: (0@0 corner: 0@0).
	parameterDisplay balloonText: (nil).
	parameterDisplay balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	parameterDisplay widgetResizable: (true).
	parameterDisplay horizontalScrollBarPolicy: (#alwaysOff).
	parameterDisplay verticalScrollBarPolicy: (#alwaysOn).
	parameterDisplay outerBorderWidth: (1).
	parameterDisplay scrollBarThickness: (9).
	parameterDisplay theText: ('find: aValue').
	parameterDisplay readOnly: (true).
	parameterDisplay autoConvert: (false).
	parameterDisplay autoAccept: (false).
	parameterDisplay acceptOnFocusLost: (false).
	parameterDisplay scrollingMode: (#none).
	parameterDisplay scrollingLimit: (10).
	parameterDisplay setProperty: #objectName toValue: 'parameterDisplay'.
	unnamedMorph6 addChild: parameterDisplay.
	codeEdit := ViSourceCodeEdit new.
	codeEdit extent: (230@292).
	codeEdit position: (381@163).
	codeEdit hResizing: (#rigid).
	codeEdit vResizing: (#spaceFill).
	codeEdit minWidth: (2).
	codeEdit minHeight: (2).
	codeEdit cellInset: (0).
	codeEdit cellPositioning: (#center).
	codeEdit cellSpacing: (#none).
	codeEdit layoutInset: (0).
	codeEdit listCentering: (#topLeft).
	codeEdit listDirection: (#topToBottom).
	codeEdit listSpacing: (#none).
	codeEdit maxCellSize: (1073741823).
	codeEdit minCellSize: (0).
	codeEdit wrapCentering: (#topLeft).
	codeEdit wrapDirection: (#none).
	codeEdit frameFractions: (0@0 corner: 1@1).
	codeEdit frameOffsets: (0@0 corner: 0@0).
	codeEdit balloonText: (nil).
	codeEdit balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.925)).
	codeEdit widgetResizable: (true).
	codeEdit horizontalScrollBarPolicy: (#alwaysOff).
	codeEdit verticalScrollBarPolicy: (#alwaysOn).
	codeEdit outerBorderWidth: (1).
	codeEdit scrollBarThickness: (9).
	codeEdit theText: ('').
	codeEdit readOnly: (false).
	codeEdit autoConvert: (false).
	codeEdit autoAccept: (false).
	codeEdit acceptOnFocusLost: (false).
	codeEdit scrollingMode: (#none).
	codeEdit scrollingLimit: (10).
	codeEdit setProperty: #objectName toValue: 'codeEdit'.
	unnamedMorph6 addChild: codeEdit.
	unnamedMorph10 := UiContainer new.
	unnamedMorph10 changeTableLayout.
	unnamedMorph10 extent: (231@42).
	unnamedMorph10 position: (381@459).
	unnamedMorph10 hResizing: (#shrinkWrap).
	unnamedMorph10 vResizing: (#shrinkWrap).
	unnamedMorph10 minWidth: (2).
	unnamedMorph10 minHeight: (2).
	unnamedMorph10 cellInset: (4).
	unnamedMorph10 cellPositioning: (#center).
	unnamedMorph10 cellSpacing: (#none).
	unnamedMorph10 layoutInset: (4).
	unnamedMorph10 listCentering: (#topLeft).
	unnamedMorph10 listDirection: (#leftToRight).
	unnamedMorph10 listSpacing: (#none).
	unnamedMorph10 maxCellSize: (1073741823).
	unnamedMorph10 minCellSize: (0).
	unnamedMorph10 wrapCentering: (#topLeft).
	unnamedMorph10 wrapDirection: (#none).
	unnamedMorph10 frameFractions: (0@0 corner: 1@1).
	unnamedMorph10 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph10 balloonText: (nil).
	unnamedMorph10 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.925)).
	unnamedMorph10 color: (Color transparent).
	unnamedMorph10 borderWidth: (0).
	unnamedMorph10 borderStyle2: (#simple).
	unnamedMorph10 borderColor: (Color black).
	unnamedMorph11 := UiContainer new.
	unnamedMorph11 changeTableLayout.
	unnamedMorph11 extent: (109@34).
	unnamedMorph11 position: (385@463).
	unnamedMorph11 hResizing: (#rigid).
	unnamedMorph11 vResizing: (#shrinkWrap).
	unnamedMorph11 minWidth: (2).
	unnamedMorph11 minHeight: (2).
	unnamedMorph11 cellInset: (4).
	unnamedMorph11 cellPositioning: (#center).
	unnamedMorph11 cellSpacing: (#none).
	unnamedMorph11 layoutInset: (4).
	unnamedMorph11 listCentering: (#topLeft).
	unnamedMorph11 listDirection: (#topToBottom).
	unnamedMorph11 listSpacing: (#none).
	unnamedMorph11 maxCellSize: (1073741823).
	unnamedMorph11 minCellSize: (0).
	unnamedMorph11 wrapCentering: (#topLeft).
	unnamedMorph11 wrapDirection: (#none).
	unnamedMorph11 frameFractions: (0@0 corner: 1@1).
	unnamedMorph11 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph11 balloonText: (nil).
	unnamedMorph11 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.925)).
	unnamedMorph11 color: (Color transparent).
	unnamedMorph11 borderWidth: (0).
	unnamedMorph11 borderStyle2: (#simple).
	unnamedMorph11 borderColor: (Color black).
	playButton := UiPushButton new.
	playButton changeTableLayout.
	playButton extent: (101@25).
	playButton position: (389@467).
	playButton hResizing: (#spaceFill).
	playButton vResizing: (#shrinkWrap).
	playButton minWidth: (2).
	playButton minHeight: (2).
	playButton cellInset: (4).
	playButton cellPositioning: (#center).
	playButton cellSpacing: (#none).
	playButton layoutInset: (2).
	playButton listCentering: (#center).
	playButton listDirection: (#leftToRight).
	playButton listSpacing: (#none).
	playButton maxCellSize: (1073741823).
	playButton minCellSize: (0).
	playButton wrapCentering: (#topLeft).
	playButton wrapDirection: (#none).
	playButton frameFractions: (0@0 corner: 1@1).
	playButton frameOffsets: (0@0 corner: 0@0).
	playButton balloonText: (nil).
	playButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	playButton enabled: (true).
	playButton setProperty: #iconByDesigner toValue: 'nil'.
	playButton icon: (nil).
	playButton text: ('Play').
	playButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	playButton checkable: (false).
	playButton checked: (false).
	playButton autoExclusive: (false).
	playButton setProperty: #objectName toValue: 'playButton'.
	unnamedMorph11 addChild: playButton.
	unnamedMorph10 addChild: unnamedMorph11.
	unnamedMorph12 := UiContainer new.
	unnamedMorph12 changeTableLayout.
	unnamedMorph12 extent: (110@34).
	unnamedMorph12 position: (498@463).
	unnamedMorph12 hResizing: (#rigid).
	unnamedMorph12 vResizing: (#shrinkWrap).
	unnamedMorph12 minWidth: (2).
	unnamedMorph12 minHeight: (2).
	unnamedMorph12 cellInset: (4).
	unnamedMorph12 cellPositioning: (#center).
	unnamedMorph12 cellSpacing: (#none).
	unnamedMorph12 layoutInset: (4).
	unnamedMorph12 listCentering: (#topLeft).
	unnamedMorph12 listDirection: (#topToBottom).
	unnamedMorph12 listSpacing: (#none).
	unnamedMorph12 maxCellSize: (1073741823).
	unnamedMorph12 minCellSize: (0).
	unnamedMorph12 wrapCentering: (#topLeft).
	unnamedMorph12 wrapDirection: (#none).
	unnamedMorph12 frameFractions: (0@0 corner: 1@1).
	unnamedMorph12 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph12 balloonText: (nil).
	unnamedMorph12 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.925)).
	unnamedMorph12 color: (Color transparent).
	unnamedMorph12 borderWidth: (0).
	unnamedMorph12 borderStyle2: (#simple).
	unnamedMorph12 borderColor: (Color black).
	stepButton := UiPushButton new.
	stepButton changeTableLayout.
	stepButton extent: (102@25).
	stepButton position: (502@467).
	stepButton hResizing: (#spaceFill).
	stepButton vResizing: (#shrinkWrap).
	stepButton minWidth: (2).
	stepButton minHeight: (2).
	stepButton cellInset: (4).
	stepButton cellPositioning: (#center).
	stepButton cellSpacing: (#none).
	stepButton layoutInset: (2).
	stepButton listCentering: (#center).
	stepButton listDirection: (#leftToRight).
	stepButton listSpacing: (#none).
	stepButton maxCellSize: (1073741823).
	stepButton minCellSize: (0).
	stepButton wrapCentering: (#topLeft).
	stepButton wrapDirection: (#none).
	stepButton frameFractions: (0@0 corner: 1@1).
	stepButton frameOffsets: (0@0 corner: 0@0).
	stepButton balloonText: (nil).
	stepButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	stepButton enabled: (true).
	stepButton setProperty: #iconByDesigner toValue: 'nil'.
	stepButton icon: (nil).
	stepButton text: ('Step').
	stepButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	stepButton checkable: (false).
	stepButton checked: (false).
	stepButton autoExclusive: (false).
	stepButton setProperty: #objectName toValue: 'stepButton'.
	unnamedMorph12 addChild: stepButton.
	unnamedMorph10 addChild: unnamedMorph12.
	unnamedMorph6 addChild: unnamedMorph10.
	unnamedMorph4 addChild: unnamedMorph6.
	stack addChild: unnamedMorph4.
	panel addChild: stack.
	panel setProperty: #uiClassName toValue: 'I2STask'.! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/12/2013 16:31:09.706'!
parameterDisplay
	"No description given."
	
	^ parameterDisplay! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/12/2013 16:31:09.8'!
playButton
	"No description given."
	
	^ playButton! !

!I2STaskUi methodsFor: 'as yet unclassified' stamp: 'dg 6/12/2013 15:59:37.208'!
runUserCode
	| userInput newMethod |

	userInput := self codeEdit sourceCode asString.
	newMethod := self parameterDisplay theText, String cr, userInput.
	I2SUserCode compile:  newMethod classified: 'userMethods'.
	
	(I2SUserCode new) findValue: 23.! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/12/2013 16:31:09.464'!
scrollArea
	"No description given."
	
	^ scrollArea! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/12/2013 16:31:09.65'!
solutionButton
	"No description given."
	
	^ solutionButton! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/12/2013 16:31:09.315'!
stack
	"No description given."
	
	^ stack! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/12/2013 16:31:09.849'!
stepButton
	"No description given."
	
	^ stepButton! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/12/2013 16:31:09.422'!
taskDescription
	"No description given."
	
	^ taskDescription! !

Morph subclass: #I2SListElementMorph
	instanceVariableNames: 'active value text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 16:17:34.599'!
activate
	active := true.
	text color: Color black.! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 14:47:39.195'!
alignText
	text position: ((self extent - text extent) / 2).! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 14:56:25.359'!
buildText
	text := TextMorph new.
	text contents: (value asString).
	text lock: true.
	text color: Color transparent.
	self addMorph: text.
	self alignText.! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 15:15:23.053'!
deactivate
	active := false.
	text color: Color transparent.! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:45:53.6'!
defaultBounds
	^0@0 corner: 50@50! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 15:11:09.039'!
initialize
	super initialize.
	
	self borderWidth: 1.
	self borderColor: Color black.
	self color: Color white.
	
	active := false.
	value := 0.
	self buildText.
	
	self on: #click send: #onClick to: self.
	self on: #mouseEnter send: #onMouseEnter to: self.
	self on: #mouseLeave send: #onMouseLeave to: self.! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 16:17:38.905'!
onClick
	active ifFalse: [
		self owner activeElement: self.
	] ifTrue: [
		self owner activeElement: nil.
	]! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 15:03:08.98'!
onMouseEnter
	self color: Color yellow muchLighter.! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 15:01:32.792'!
onMouseLeave
	self color: Color white.! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 14:28:11.813'!
value
	^value! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:36:28.677'!
value: aValue.
	value := aValue.
	text contents: aValue asString.
	self alignText.! !

Morph subclass: #I2SListMorph
	instanceVariableNames: 'activeElement list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SListMorph class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:51:28.947'!
newWithList: aList
	|out|
	
	out := self basicNew.
	out list: aList.
	out initialize.
	
	^out! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 16:04:04.271'!
actionPerformed
	self emit.! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:46:00.362'!
activeElement
	^activeElement! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 16:07:30.941'!
activeElement: anElement.
	self actionPerformed.

	activeElement ifNotNil:[
		activeElement deactivate.	
	].	
	activeElement := anElement.
	anElement ifNotNil:[
		anElement activate.
		self valueSelected: anElement value.
	].! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:50:50.297'!
draw
	| offset |
	
	offset := 0.
	
	self list do: [:ea| |morph|
		morph := I2SListElementMorph new.
		morph value: ea.
		morph left: offset.
		self addMorph: morph.
		offset := offset + morph width.].
	
	self extent: self fullBounds extent.! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:50:35.167'!
initialize
	super initialize.
	self color: Color transparent.
	self borderWidth: 1.
	self borderColor: Color black.
	
	activeElement := nil.
	self draw.! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:51:10.933'!
list
	list ifNil:[
		list := {}.	
	].
	^list! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 12:01:35.303'!
list: aList.
	list := aList.! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 14:57:09.673'!
valueSelected: aValue
	self emit.! !

Morph subclass: #I2SVisualization
	instanceVariableNames: 'rootNode visualNodeMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

I2SVisualization subclass: #I2STreeSectionMorph
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:24:55.794'!
childrenConnectorStart

	^50@100! !

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:25:22.139'!
currentNodePosition

	^ 30@60! !

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:25:18.908'!
leftChildPosition

	^ 0@120! !

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:25:25.964'!
leftConnectorEnd
	
	^20@120! !

!I2STreeSectionMorph class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 15:36:50.937'!
newWithList: aList
 | a |
	a := self new.
	a node: (I2SBinarySearchTreeNode newWithList: aList).
	^a! !

!I2STreeSectionMorph class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/30/2013 17:07:14.685'!
newWithNode: aNode
 | a |
	a := self new.
	a node: aNode.
	^a! !

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:37:51.574'!
parentConnectorEnd

 	^50@40! !

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:38:06.112'!
parentConnectorStart

	^50@60! !

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:38:01.496'!
parentNodePosition

	^ 30@0! !

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:37:59.251'!
rightChildPosition

	^ 60@120! !

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:37:55.185'!
rightConnectorEnd

	^80@120! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 16:05:41.814'!
actionPerformed
	self emit.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/30/2013 17:17:09.317'!
addNode: aNode atPosition: aPosition
	| node |
	node := (I2SVisualNode newWithNode: aNode renderDepth: 1 on: self).
	self addMorph: node.
	node position: (self position + aPosition).
	
	^ node! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/5/2013 17:41:21.206'!
animateGoLeftThen: aBlock

	(self getVisualNodeFor: self node) 
		walkToPosition: self position + self class parentNodePosition.
		
	(self getVisualNodeFor: self node leftChild ) 
		walkToPosition: self position + self class currentNodePosition
			then: [self finishGoLeftThen: aBlock].! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/12/2013 12:43:26.672'!
animateGoRightThen: aBlock

	(self getVisualNodeFor: self node) 
		walkToPosition: self position + self class parentNodePosition.
		
	(self getVisualNodeFor: self node rightChild) 
		walkToPosition: self position + self class currentNodePosition
			then: [self finishGoRightThen: aBlock].! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/12/2013 13:54:54.132'!
animateGoUpThen: aBlock

	| newPosition |
	(self node = (self node parent) leftChild)
		ifTrue: [newPosition := self class leftChildPosition]
		ifFalse: [newPosition := self class rightChildPosition].
		
	(self getVisualNodeFor: self node) 
		walkToPosition: self position + newPosition.
		
	(self getVisualNodeFor: self node parent) 
		walkToPosition: self position + self class currentNodePosition
			then: [self finishGoUpThen: aBlock].! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 12:39:36.534'!
draw
	self drawThen: [].! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 14:48:36.131'!
drawConnectorFrom: aStart to: anEnd

	^ (LineMorph 
		from: (self position + aStart) 
		to: (self position + anEnd)
		color: Color black
		width: 5).! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/5/2013 16:26:37.86'!
drawCurrentNode
	| activeNodeMorph |
	activeNodeMorph := (I2SVisualNode newWithNode: self node renderDepth: 1 on: self).
	self addMorph: activeNodeMorph.
	activeNodeMorph position: (self position + self class currentNodePosition).! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 14:59:42.226'!
drawEdgeFrom: aStart to: anEnd

	^ (LineMorph 
		from: (self position + aStart) 
		to: (self position + anEnd)
		color: Color black
		width: 5).! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 15:58:28.261'!
drawLeftChild

	| leftVis edge|
	leftVis := self addNode: self node leftChild atPosition: self class leftChildPosition.
	
	edge := self drawEdgeFrom: self class childrenConnectorStart 
		to: self class leftConnectorEnd.
		
	leftVis parentEdge: edge.
	self addMorph: edge.
	
	(self getVisualNodeFor: self node) childEdges add: edge.
	leftVis on: #click send: #goLeft to: self.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/5/2013 16:26:53.216'!
drawParentNode
	| parentVis edge|
	parentVis := self addNode: self node parent atPosition: self class parentNodePosition.
	
	edge := self drawEdgeFrom: self class parentConnectorStart 
		to: self class parentConnectorEnd.
		
	(self getVisualNodeFor: self node) parentEdge: edge.
	self addMorph: edge.
	parentVis childEdges add: edge.
	parentVis on: #click send: #goUp to: self.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/5/2013 16:27:00.494'!
drawRightChild
	| rightVis edge|
	rightVis := self addNode: self node rightChild 
		atPosition: self class rightChildPosition.
	
	edge := self drawEdgeFrom: self class childrenConnectorStart 
		to: self class rightConnectorEnd.
		
	rightVis parentEdge: edge.
	self addMorph: edge.
	
	(self getVisualNodeFor: self node) childEdges add: edge.
	rightVis on: #click send: #goRight to: self.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/5/2013 17:45:35.552'!
drawThen: aBlock
	"self submorphs do: [:ea |  
		ea fadeOut ]."
	| oldMorphs done |
	oldMorphs := self submorphs copy.
	
	self drawCurrentNode.
	
	self node leftChild ifNotNil: [
		self drawLeftChild.
	].
	
	self node rightChild ifNotNil: [
		self drawRightChild.
	].
	
	self node parent ifNotNil: [
		self drawParentNode.
	].

"	self submorphs do: [:ea | (oldMorphs indexOf: ea) = 0 ifFalse: [ ea fadeIn ]]."
	done := false.
	(self submorphs difference: oldMorphs) do: [:ea | ea fadeInThen: [
			done ifFalse: [
				oldMorphs do: [:oldMorph | oldMorph delete.].
				aBlock value.
			].
			done := true.
			].].

	self extent: 100@160.! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'dustin.glaeser 6/5/2013 13:23:59.563'!
fadeOutNode: aNode then: aBlock ifNot: callbackSet

	aNode ifNotNil: [
		callbackSet
			ifTrue: [(self getVisualNodeFor: aNode) fadeOut]
			ifFalse:[(self getVisualNodeFor: aNode) fadeOutThen: aBlock].
		((self getVisualNodeFor: aNode) edges) do: [ :edge | edge fadeOut].
		^ true].
	
	^ callbackSet! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/5/2013 17:41:43.66'!
finishGoLeftThen: aBlock

	self node: self node leftChild.
	self drawThen: aBlock.! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/12/2013 12:48:30.578'!
finishGoRightThen: aBlock

	self node: self node rightChild.
	self drawThen: aBlock.! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/12/2013 13:55:11.985'!
finishGoUpThen: aBlock

	self node: self node parent.
	self drawThen: aBlock.! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/12/2013 12:40:06.905'!
goLeft
	self actionPerformed.
	self goLeftThen: [].! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/5/2013 17:51:56.679'!
goLeftThen: aBlock
	| callbackSet | 
	
	callbackSet := false.
	callbackSet := self fadeOutNode: self node parent 
		then: [self animateGoLeftThen: aBlock.] ifNot: callbackSet.
	callbackSet := self fadeOutNode: self node rightChild 
		then: [self animateGoLeftThen: aBlock.] ifNot: callbackSet.
		
	callbackSet ifFalse: [self animateGoLeftThen: aBlock.].! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/12/2013 12:44:05.548'!
goRight
	self actionPerformed.
	self goRightThen: [].! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/12/2013 12:44:46.475'!
goRightThen: aBlock
	
	| callbackSet | 
	callbackSet := false.
	callbackSet := self fadeOutNode: self node parent 
		then: [self animateGoRightThen: aBlock] ifNot: callbackSet.
	callbackSet := self fadeOutNode: self node leftChild  
		then: [self animateGoRightThen: aBlock] ifNot: callbackSet.
		
	callbackSet ifFalse: [self animateGoRightThen: aBlock].! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/12/2013 13:55:29.841'!
goUp
	self actionPerformed.
	self goUpThen: [].! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/12/2013 13:55:40.649'!
goUpThen: aBlock
	| callbackSet | 
	callbackSet := false.
	callbackSet := self fadeOutNode: self node leftChild  
		then: [self animateGoUpThen: aBlock] ifNot: callbackSet.
	callbackSet := self fadeOutNode: self node rightChild  
		then: [self animateGoUpThen: aBlock] ifNot: callbackSet.
		
	callbackSet ifFalse: [self animateGoUpThen: aBlock].! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/5/2013 16:14:56.008'!
initialize
	super initialize.
	self color: Color transparent.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/29/2013 11:32:06.562'!
node
	^node! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 14:54:01.091'!
node: aNode
	node := aNode.
	self draw.
	self valueSelected: aNode value.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:18:17.805'!
setRootNode: aNode
	self node: aNode.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 14:54:19.557'!
valueSelected: aValue
	self emit.! !

!I2SVisualization class methodsFor: 'as yet unclassified' stamp: 'dg 5/8/2013 14:35:08.134'!
newWithNode: aNode

  	|a visNode |
  	a := self new.
	a setRootNode: aNode.
	
	^a
  ! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 12:22:10.297'!
addedChild: aNode to: aParent at: aPosition

	self updateTree.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 16:27:19.712'!
animateToNewNodePositions: aNode left: aBoolean
	| newVis callbackCounter |
	callbackCounter := 0.
	self hideEdgesForNodeRotation: aNode left: aBoolean then: [newVis := self class newWithNode: self rootNode.
	"iterate over own visnodes"
	visualNodeMap do: [:ea ||dataNode newVisNode|
		"get the data node for the visual node"
		dataNode := ea node.
		"find the corresponding visual node in the new tree"
		newVisNode := newVis getVisualNodeFor: dataNode.
		
		"animate the position of the current node to the new position"
		ea walkToPosition: newVisNode position then: [
			callbackCounter := callbackCounter + 1.
			callbackCounter = visualNodeMap size ifTrue: [
				self updateTree.
			].
		].
	].].
	
	! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:46:52.204'!
getVisualNodeFor: aTreeNode

	^visualNodeMap at: aTreeNode ifAbsent: nil! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 15:47:07.466'!
hideEdgesForNodeRotation: aNode left: aBoolean
	|visNode|
	visNode := self getVisualNodeFor: aNode.
	visNode parentEdge fadeOutThen: [].
	aBoolean ifTrue: [
		(visNode childEdges at: 2) fadeOut.
	] ifFalse: [
		(visNode childEdges at: 1) fadeOut.
	]
	! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 16:12:06.727'!
hideEdgesForNodeRotation: aNode left: aBoolean then: aBlock
	|visNode|
	visNode := self getVisualNodeFor: aNode.
	visNode parentEdge fadeOutThen: aBlock.
	aBoolean ifTrue: [
		|rightChild|
		(visNode childEdges at: 2) fadeOut.
		aNode rightChild ifNotNil: [
			rightChild := aNode rightChild.
			((self getVisualNodeFor: rightChild) parentEdge) fadeOut.
		].
		
	] ifFalse: [
		|leftChild|
		(visNode childEdges at: 1) fadeOut.
		aNode leftChild ifNotNil: [
			leftChild := aNode leftChild.
			((self getVisualNodeFor: leftChild) parentEdge) fadeOut.
		].
	]
	! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 18:59:34.593'!
initialize 
	super initialize.
	visualNodeMap := Dictionary new.
	color := Color transparent.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 12:33:12.866'!
removedChild: aNode from: aParent at: aPosition

	self updateTree.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:46:55.22'!
rootNode
	^rootNode! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 12:11:04.226'!
rootNode: aNode
	rootNode := aNode.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 15:40:31.377'!
rotateLeft: aNode
	self animateToNewNodePositions: aNode left: true.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 15:40:52.662'!
rotateRight: aNode
	self animateToNewNodePositions: aNode left: false.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 17:32:49.965'!
setRootNode: aRoot

	| visNode |
	self rootNode: aRoot.

  	visNode := (I2SVisualNode newWithNode: aRoot on: self).
  	self addMorph: visNode.
	visNode visualization: self.
  	self extent: visNode fullBounds extent.
	visNode position: visNode position - self fullBounds topLeft.
	
	visualNodeMap at: aRoot put: visNode .

  	self position: ActiveWorld visibleClearArea origin.

 	self setupConnections.
  	^self! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 14:33:29.818'!
setVisualNode: aVisNode for: aTreeNode

	visualNodeMap at: aTreeNode put: aVisNode.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 14:35:56.417'!
setupConnections

	self connect: self rootNode signal: #addedChild:to:at: toSelector: #addedChild:to:at:.
	
	self connect: self rootNode signal: #removedChild:from:at: toSelector: #removedChild:from:at:.
	
	self connect: self rootNode signal: #rotatedLeft: toSelector: #rotateLeft:.
	
	self connect: self rootNode signal: #rotatedRight: toSelector: #rotateRight:.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 14:52:00.506'!
updateTree
	| visNode |
	self removeAllMorphs.
	visNode := (I2SVisualNode newWithNode:  self rootNode on: self).
  self bounds: visNode fullBounds.
  self addMorph: visNode.
  self position: ActiveWorld visibleClearArea origin.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 18:54:42.404'!
visualNodeMap
	
	^visualNodeMap! !

TestCase subclass: #I2SListMorphTests
	instanceVariableNames: 'list listMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching-Tests'!

!I2SListMorphTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 17:14:14.592'!
setUp
	| r |
	super setUp.
	r := Random new.
	list := r next: 20.
	listMorph := I2SListMorph newWithList: list.
	listMorph draw.
	listMorph openInWorld.! !

!I2SListMorphTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 17:14:12.975'!
tearDown
	super tearDown.
	listMorph delete.! !

!I2SListMorphTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 17:14:32.564'!
test01length
	self assert: 20 equals: (listMorph submorphs size).
	self assert: list equals: listMorph list.! !

!I2SListMorphTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 17:20:37.887'!
test02values
	(1 to: 20) do: [:i|
			self assert: (list at: (21 - i)) equals: ((listMorph submorphs at: i) value).
			self assert:
				((20-i) * (I2SListElementMorph new defaultBounds width))
				equals:
				(((listMorph submorphs at: i) position x) - (listMorph position x)).
	].! !

!I2SListMorphTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 17:21:04.968'!
test03highlighting
	| m |
	m := listMorph submorphs at: 5.
	m onMouseEnter.
	self assert: Color yellow muchLighter equals: m color.
	m onMouseLeave.
	self assert: Color white equals: m color.! !

!I2SListMorphTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 17:21:50.567'!
test04uncovering
	| m m2|
	m := listMorph submorphs at: 5.
	m2 := listMorph submorphs at: 17.
	self assert: Color transparent equals: m submorphs first color.
	self assert: Color transparent equals: m2 submorphs first color.
	m onClick.
	self assert: Color black equals: m submorphs first color.
	self assert: Color transparent equals: m2 submorphs first color.
	self assert: m equals: listMorph activeElement.
	m2 onClick.
	self assert: Color transparent equals: m submorphs first color.
	self assert: Color black equals: m2 submorphs first color.
	self assert: m2 equals: listMorph activeElement.
	m2 onClick.
	self assert: Color transparent equals: m submorphs first color.
	self assert: Color transparent equals: m2 submorphs first color.! !

TestCase subclass: #I2STreeNodeTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching-Tests'!

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 16:18:11.279'!
setUp
	super setUp.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 16:26:52.118'!
tearDown
	super tearDown.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 12:45:48.174'!
test01Initialisation
	| a |
	a := I2STreeNode newWithValue: #a.
	self assert: #a equals: (a getValueAt: 1).
	self assert: (a hasChildren) not.
	self assert: 0 equals: (a numChildren).! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 13:54:01.813'!
test02Limits
	| a |
	a := I2STreeNode new.
	a maxChildren: 2.
	a maxValues: 1.
	
self should: [a getValueAt: 0] raise: Error.
self shouldnt: [a getValueAt: 1] raise: Error.
self should: [a getValueAt: 2] raise: Error.
self should: [a setValue: 0 at: 0] raise: Error.
self shouldnt: [a setValue: 0 at: 1] raise: Error.
self should: [a setValue: 0 at: 2] raise: Error.
self should: [a getChildAt: 0] raise: Error.
self shouldnt: [a getChildAt: 1] raise: Error.
self shouldnt: [a getChildAt: 2] raise: Error.
self should: [a getChildAt: 3] raise: Error.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/5/2013 17:31:14.94'!
test03Children
	| a b c |
	a := I2STreeNode new.
	b := I2STreeNode new.
	c := I2STreeNode new.
	
	a addChild: b at: 1.
	self assert: b equals: (a getChildAt: 1).
	a addChild: c at: 2.
	self assert: c equals: (a getChildAt: 2).
	self assert: a equals: (b parent).
	self assert: a equals: (c parent).
	
	a removeChildAt: 1.
	self assert: ((a getChildAt: 1) isNil).
	self assert: (b parent isNil).
	self assert: c equals: (a getChildAt: 2).
	self assert: a equals: (c parent).
	a removeChildAt: 2.
	self assert: (a getChildAt: 2) isNil.
	self assert: c parent isNil.
	
	! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 13:57:07.369'!
test04ChildrenAndLimits
	| a b |
	a := I2STreeNode new.
	b := I2STreeNode new.
	a maxChildren: 1.
	
	self should: [ a addChild: b at: 0] raise: Error.
	self should: [ a addChild: b at: 2] raise: Error.
	self shouldnt: [ a addChild: b at: 1] raise: Error.
	
	self should: [a removeChildAt: 0] raise: Error.
	self should: [a removeChildAt: 2] raise: Error.
	self shouldnt: [a removeChildAt: 1] raise: Error.
	! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 14:29:06.552'!
test05BinaryTree
	| a b c |
	a := I2SBinaryTreeNode newWithValue: 5.
	self assert: 1 equals: a maxValues.
	self assert: 2 equals: a maxChildren.
	self assert: 5 equals: a value.
	
	b := I2SBinaryTreeNode newWithValue: 3.
	c := I2SBinaryTreeNode newWithValue: 7.
	
	a leftChild: b.
	self assert: b equals: a leftChild.
	a leftChild: c.
	self assert: c equals: a leftChild.
	a rightChild: b.
	self assert: b equals: a rightChild.
	
	c value: 8.
	self assert: 8 equals: c value.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:16:59.938'!
test06BinarySearchTree
	| root |
	root := I2SBinarySearchTreeNode newWithValue: 5.
	root addValue: 3.
	root addValue: 7.
	root addValue: 14.
	root addValue: 4.
	
	self assert: 5 equals: root value.
	self assert: 3 equals: root leftChild value.
	self assert: 7 equals: root rightChild value.
	self assert: 14 equals: root rightChild rightChild value.
	self assert: (root leftChild leftChild) isNil.
	self assert: (root rightChild leftChild) isNil.
	self assert: (root find: 5).
	self assert: (root find: 7).
	self assert: (root find: 3).
	self assert: (root find: 14).
	self assert: (root find: 4).
	self assert: (root find: 20) not.
	self assert: (root find: 10) not.
	self assert: (root find: 0) not.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/30/2013 17:51:31.112'!
test07RandomBinaryTree
	| tree |
	tree := I2SBinaryTreeNode randomTree.
	self assert: (tree numChildren >= 1).! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/30/2013 17:52:41.675'!
test08RandomBinarySearchTree
	| tree |
	tree := I2SBinarySearchTreeNode randomTree.
	self assert: (tree numChildren >= 1).! !

TestCase subclass: #I2STreeSectionMorphTests
	instanceVariableNames: 'vis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching-Tests'!

!I2STreeSectionMorphTests methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/30/2013 17:11:15.53'!
setUp
	super setUp.
	vis := I2STreeSectionMorph new.! !

!I2STreeSectionMorphTests methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/30/2013 17:11:12.372'!
tearDown
	vis delete.
	super tearDown.! !

!I2STreeSectionMorphTests methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 14:09:34.67'!
testNavigation
	| root left right |
	root := I2SBinaryTreeNode new.
	root value: 3.
	
	left := I2SBinaryTreeNode new.
	left value: 5.
	root leftChild: left.
	
	right := I2SBinaryTreeNode new.
	right value: 4.
	root rightChild: right.
	
	(vis node: root) openInWorld.
	
	self assert: 5 equals: vis submorphs size.
	"we can't use assertions in the callback, because the image will freeze."
	vis goRightThen: [vis goUpThen: [vis goRight.].].
! !

TestCase subclass: #I2SVisualizationTests
	instanceVariableNames: 'visualization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching-Tests'!

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dg 5/8/2013 14:50:14.849'!
setUp
	
	super setUp.
	visualization := I2SVisualization new. 
	! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 11:44:04.316'!
tearDown
	
	visualization delete.
	super tearDown! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dg 5/8/2013 14:28:54.794'!
test01SimpleTree
	| a b c |
	a := I2STreeNode new.
	a setValue: Color red at: 1.

	b := I2STreeNode new.
	b setValue: Color blue at: 1.

	c := I2STreeNode new.
	c setValue: Color blue at: 1.

	a addChild: b at: 1.
	a addChild: c at: 2.

	(visualization setRootNode: a)	openInWorld.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:32:18.954'!
test02UpdateTree

	| root child |
	root := I2STreeNode new.
	
	(visualization setRootNode: root) openInWorld.
	
	child := I2STreeNode new.
	
	root addChild: child at: 1.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:30:58.813'!
test03RemoveChild

	| root child |
	root := I2STreeNode new.
			
	child := I2STreeNode new.
	
	root addChild: child at: 1.
	
	(visualization setRootNode: root) openInWorld.
		
	root removeChildAt: 1.
! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:29:32.808'!
test04MoarDepth
	| a b c d |
	a := I2STreeNode new.

	b := I2STreeNode new.

	c := I2STreeNode new.
	
	d := I2STreeNode new.

	a addChild: b at: 1.
	a addChild: c at: 2.
	b addChild: d at: 1. 
	
	(visualization setRootNode: a) openInWorld.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:40:37.672'!
test05ComplexTree

| a b c d e f |
	a := I2STreeNode new.
	a color: Color red.

	b := I2STreeNode new.
	b color: Color blue.

	c := I2STreeNode new.
	c color: Color blue.

	d := I2STreeNode new.
	e := I2STreeNode new.
	f := I2STreeNode new.

	a addChild: b at: 1.
	a addChild: c at: 2.
	b addChild: d at: 1. 
	b addChild: e at: 2.
	c addChild: f at: 1.

	(visualization setRootNode: a) openInWorld.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 15:41:25.401'!
testBuildBinaryTreeFromRoot

	| root nodeOne nodeTwo |
	root := I2SBinaryTreeNode new.
	nodeOne := I2SBinaryTreeNode new.
	nodeTwo := I2SBinaryTreeNode new.
	
	root color: Color red.
	
	root rightChild: nodeOne.
	nodeOne rightChild: nodeTwo.
	
	(visualization setRootNode: root) openInWorld.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 15:47:17.087'!
testDefaultColor
	
	| node description|
	node := I2STreeNode new.
	visualization setRootNode: node.
	
	description := 'Every node needs a default color for visualization.'.
	self assert: 
		[(visualization getVisualNodeFor: node) color = Color orange]
		description: description.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 15:39:33.432'!
testVisualizationAssignment

	| root child child2 child3 aTreeNode|
	
	root := I2STreeNode new.
	child := I2STreeNode new.
	child2 := I2STreeNode new.
	child3 := I2STreeNode new.
	
	root addChild: child at: 1.
	root addChild: child2 at: 2.
	child2 addChild: child3 at: 1.
	
	(visualization setRootNode: root) openInWorld.
	self assert: (visualization submorphs at: 1) 
		equals: (visualization getVisualNodeFor: root).

	"Is there a better, more stable way to test this?"
	self assert: ((visualization getVisualNodeFor: root) 
						submorphs at: 4)
		equals: (visualization getVisualNodeFor: child).
	
	self assert: (((visualization getVisualNodeFor: root)
						submorphs at: 2) submorphs at: 2)
		equals: (visualization getVisualNodeFor: child3).
	
	"less moph-structure dependent approach"
	aTreeNode := (visualization getVisualNodeFor: child3) node.
	self assert: root equals: 
		aTreeNode parent parent.
	
	! !

TestCase subclass: #TaskUiTests
	instanceVariableNames: 'task ui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching-Tests'!

!TaskUiTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 14:48:26.186'!
setUp
	super setUp.
	task := I2STestTask new.
	task description: 'This is a test Task.'.
	task hints: OrderedCollection new.
	task addHint: 'This is Hint number 1.'.
	task addHint: 'This is Hint number 2.'.
	ui := I2SActiveTaskUi newWithTask: task.
	ui panel openInWorld.! !

!TaskUiTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 17:34:01.924'!
tearDown
	super tearDown.
	ui panel delete.! !

!TaskUiTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 17:35:36.31'!
test01Description
	self assert: task description equals: ui taskDescription theText string.! !

!TaskUiTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 17:44:42.378'!
test02Hints
	ui hintButton press: nil.
	self assert: (task hints at: 1) equals:(ui taskDescription theText string lines at: 2).
	ui hintButton press: nil.
	self assert: (task hints at: 2) equals:(ui taskDescription theText string lines at: 3).
	ui hintButton press: nil.
	self assert: (task hints at: 1) equals:(ui taskDescription theText string lines at: 4).! !

Object subclass: #I2STask
	instanceVariableNames: 'description hints unveiled completed visualization clickCount userCode userCodeSignature'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

I2STask subclass: #I2SSearchTask
	instanceVariableNames: 'value visualizationClass list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SSearchTask class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:45:43.996'!
newWithValue: aValue andList: aList
	| a |
	a := self basicNew.
	a value: aValue.
	a list: aList.
	
	a initialize.
	^a.! !

!I2SSearchTask class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 17:03:41.292'!
newWithVisualizationClass: aClass andValue: aValue andList: aList
	| a |
	a := self basicNew.
	a visualizationClass: aClass.
	a value: aValue.
	a list: aList.
	
	a initialize.
	^a.! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 16:08:06.666'!
checkValue: aValue
	(aValue = self value) ifTrue: [
		self completed: true.
	].! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:44:15.34'!
initialize
	super initialize.
	
	self description: (('Find the Number ', self value), ', please!!').! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:35:39.547'!
list
	^list! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:35:21.437'!
list: aList
	list := aList.! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:47:06.378'!
setUpVisualization
	^self visualizationClass newWithList: self list! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:55:15.996'!
setupConnections
	self
		connect: self visualization 
		signal: #valueSelected:
		toSelector: #checkValue:! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:35:43.12'!
value
	^value! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:19:14.95'!
value: aValue
	value := aValue.! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:37:37.013'!
visualizationClass
	visualizationClass ifNil:
	[
		visualizationClass := I2SListMorph.
	].
	^visualizationClass! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:36:04.552'!
visualizationClass: aClass
	visualizationClass := aClass.! !

!I2STask class methodsFor: 'as yet unclassified' stamp: 'dg 6/12/2013 16:15:20.532'!
defaultUserCode

	^ 
		'self goLeft.', String cr,
		'(self value = aValue) ifTrue: [ Transcript showln: ''Success!!'']', 
			String cr,
		'ifFalse: [ Transcript showln: ''Fail :(''].'! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 16:02:44.736'!
addHint: aString
	self hints add: aString.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 15:56:40.108'!
clickCount
	^clickCount.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 15:56:32.094'!
clickCount: aNumber
	clickCount := aNumber.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 12:00:00.581'!
completed
	^completed! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 12:00:09.436'!
completed: aBoolean
	completed := aBoolean.
	self emitAlways.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 16:01:18.093'!
description
	^ description! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 16:01:35.016'!
description: aString
	description := aString.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 16:05:16.263'!
hints
	^hints! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 16:02:21.444'!
hints: aCollection
	hints := aCollection.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 15:59:08.453'!
incrementClickCount
	self clickCount: (self clickCount + 1)! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'dg 6/12/2013 16:15:25.831'!
initialize
	super initialize.
	
	self description: ''.
	self userCodeSignature: 'findValue: aValue'.
	self userCode: self class defaultUserCode.
	
	self hints: OrderedCollection new.
	
	self reset.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 15:31:55.545'!
nextHint
	(self hints size = 0) ifTrue: [
		^ 'there are no hints'.
	].
	(self unveiled < self hints size) ifFalse: [
		self unveiled: 0.
	].
		self unveiled: self unveiled + 1.
		^self hints at: self unveiled! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 16:03:02.87'!
reset
	self unveiled: 0.
	self completed: false.
	self visualization: self setUpVisualization.
	
	self clickCount: 0.
	self
		connect: visualization
		signal: #actionPerformed
		toSelector: #incrementClickCount .! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 11:52:46.666'!
setUpVisualization
	self subclassResponsibility.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 13:19:30.507'!
setupConnections! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 16:05:21.006'!
unveiled
	^unveiled! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 16:05:51.846'!
unveiled: aNumber
	unveiled := aNumber.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'dg 6/12/2013 15:19:08.942'!
userCode
	^ userCode! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'dg 6/12/2013 15:19:09.804'!
userCode: aString
	userCode := aString! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'dg 6/12/2013 16:06:01.48'!
userCodeSignature
	^ userCodeSignature! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'dg 6/12/2013 15:19:10.666'!
userCodeSignature: aString
	userCodeSignature := aString! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 11:52:01.239'!
visualization
	^visualization! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 13:19:15.027'!
visualization: aVisualization
	visualization ifNotNil:[
		visualization disconnectAllSignals.	
	].
	visualization := aVisualization.
	self setupConnections.
	self emitAlways.! !

I2STask subclass: #I2STestTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching-Tests'!

!I2STestTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 14:55:06.748'!
checkValue: aValue
	self completed: (aValue = 42).! !

!I2STestTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 13:22:34.962'!
checkValueOfNode: aNode
	self completed: (aNode value = 42).! !

!I2STestTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 13:04:43.962'!
initialize 
	super initialize.
	self description: 'Find the answer to life, the universe and everything!!'.
	self addHint: 'The answer is 42.'. 
	self addHint: 'The question is unknown, though.'.! !

!I2STestTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 13:17:18.061'!
setUpVisualization
	| root r |
	r := Random new.
	root := I2SBinarySearchTreeNode newWithValue: (r next * 100) asInteger.
	(r next: 50) do: [ :ea |
		root addValue: (ea * 100) asInteger.
	].
	root addValue: 42.
	(r next: 50) do: [ :ea |
		root addValue: (ea * 100) asInteger.
	].
	^ I2STreeSectionMorph newWithNode: root.! !

!I2STestTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 14:54:51.16'!
setupConnections
	self
		connect: self visualization
		signal: #valueSelected:
		toSelector: #checkValue:.
		! !

Object subclass: #I2STreeNode
	instanceVariableNames: 'parent children numChildren values maxChildren maxValues color silent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

I2STreeNode subclass: #I2SBinaryTreeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

I2SBinaryTreeNode subclass: #I2SBinarySearchTreeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SBinarySearchTreeNode class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 15:35:29.029'!
newWithList: aList
	|node|
	node := self new.
	aList do: [:ea|
		node addValue: ea.	
	].
	^node.! !

!I2SBinarySearchTreeNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/30/2013 16:10:51.987'!
randomTree

| a r |
 r := Random new.
 a := self newWithValue: (r next * 100) asInteger. 
0 to: 20 do: [ :i |
	a addValue: (r next * 100) asInteger.
].
 ^a! !

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 15:36:18.155'!
addValue: aValue
	self value ifNil: [
		self value: aValue.
		^self.
	].

	(self value > aValue) ifTrue:[
		self leftChild ifNil: [
				self leftChild: (I2SBinarySearchTreeNode newWithValue: aValue).
			] ifNotNil: [
				self leftChild addValue: aValue.
			].
		]ifFalse:[
			self rightChild ifNil: [
				self rightChild: (I2SBinarySearchTreeNode newWithValue: aValue).
			] ifNotNil: [
				self rightChild addValue: aValue.
			].
		]! !

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:56:17.112'!
find: aValue

	^(self findNodeForValue: aValue) isNil not! !

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:45:06.472'!
findNodeForValue: aValue

	(self value = aValue) ifTrue: [
		^self
	] ifFalse: [
		(self value > aValue) ifTrue:[
			self leftChild ifNil: [
				^nil
			] ifNotNil: [
				^self leftChild findNodeForValue: aValue
			]
		] ifFalse:[
			self rightChild ifNil: [
				^nil
			] ifNotNil: [
				^self rightChild findNodeForValue: aValue
			]
		]
	].! !

!I2SBinarySearchTreeNode methodsFor: 'initialize-release' stamp: 'benjamin.siegmund 5/15/2013 11:06:37.881'!
initialize

	super initialize.! !

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 16:30:16.149'!
leftMostAncestor 
	self leftChild ifNil: [
		^self
	] ifNotNil: [
		^self leftChild leftMostAncestor
	].! !

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 16:31:02.453'!
remove: aValue
	| node |
	
	node := self findNodeForValue: aValue.
	node ifNotNil:[
		node rightChild ifNil:[ | child |
			child := node leftChild.
			node leftChild: nil.
			node parent replace: node with: child.
		] ifNotNil: [
			node leftChild ifNil:[ | child |
				child := node rightChild.
				node rightChild: nil.
				node parent replace: node with: child.
			] ifNotNil:[ | leaf child |
				leaf := node rightChild leftMostAncestor.
				node value: leaf value.
				child := leaf rightChild.
				leaf rightChild: nil.
				leaf parent replace: leaf with: child.
			]
		]
	]! !

!I2SBinaryTreeNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/30/2013 16:24:05.099'!
randomTree

| a r |
 a := self new.
 r := Random new.
 a value: (r next * 100) asInteger.
 0 to: 20 do: [ :i |
	a addValueRandomly: (r next * 100) asInteger.
].
 ^a! !

!I2SBinaryTreeNode methodsFor: 'private' stamp: 'sebastian.stamm 5/30/2013 16:23:09.957'!
addValueRandomly: aValue

 | r |
 r := Random new.
 r next < 0.5 ifTrue: [
	self leftChild ifNil: [
		| a |
		a := self class new.
		a value: aValue.
		self leftChild: a.
	] ifNotNil: [
		self leftChild addValueRandomly: aValue.
	]
 ] ifFalse: [
	self rightChild ifNil: [
		| a |
		a := self class new.
		a value: aValue.
		self rightChild: a.
	] ifNotNil: [
		self rightChild addValueRandomly: aValue.
	]
 ]! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 16:34:28.432'!
initialize

	super initialize.
	self maxChildren: 2.
	self maxValues: 1.
	self children add: nil.
	self children add: nil.! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:45:37.869'!
leftChild

	^self getChildAt: 1! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:36:17.767'!
leftChild: aNode

	self leftChild ifNotNil: [
		self removeChildAt: 1.].
	
	aNode ifNotNil:[
		self addChild: aNode at: 1.].! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:45:40.078'!
rightChild

	^self getChildAt: 2! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:36:25.394'!
rightChild: aNode
	
	self rightChild ifNotNil:[
		self removeChildAt: 2.].
	aNode ifNotNil:[
		self addChild: aNode at: 2.].! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 15:19:40.92'!
rotateLeft
	| p rc rlc |
	self rightChild ifNil: [
		self error: 'not allowed for this node'.
	].
	p := self parent.
	rc := self rightChild.
	rlc := self rightChild leftChild.
	
	p beSilent.
	self rightChild: nil.
	rc leftChild: nil.
	p ifNotNil: [
		p replace: self with: rc.
	].
	self rightChild: rlc.
	rc leftChild: self.
	p beNotSilent.
	
	self rotatedLeft: self.
	
	^self parent ! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 15:20:03.536'!
rotateRight
	| p lc lrc |
	self leftChild ifNil: [
		self error: 'not allowed for this node'.
	].
	p := self parent.
	lc := self leftChild.
	lrc := self leftChild rightChild.
	
	p beSilent.
	self leftChild: nil.
	lc rightChild: nil.
	p ifNotNil: [
		p replace: self with: lc.
	].
	self leftChild: lrc.
	lc rightChild: self.
	p beNotSilent.
	
	self rotatedRight: self.
	
	^self parent ! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 15:18:37.468'!
rotatedLeft: node
	
	self silent ifFalse: [
		self parent ifNil: [
			self emitAlways.
		] ifNotNil: [
			self parent rotatedLeft: node.
		].
	].! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 15:19:04.673'!
rotatedRight: node
	
	self silent ifFalse: [
		self parent ifNil: [
			self emitAlways.
		] ifNotNil: [
			self parent rotatedRight: node.
		].
	]! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:45:42.497'!
value
	^self getValueAt: 1! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 14:38:34.794'!
value: aValue
	self setValue: aValue at: 1.! !

!I2STreeNode class methodsFor: 'constructors' stamp: 'benjamin.siegmund 5/29/2013 16:46:43.51'!
newWithValue: aValue
	| out |
	out := self new.
	out setValue: aValue at: 1.
	^out! !

!I2STreeNode methodsFor: 'accessing' stamp: 'sebastian.stamm 6/12/2013 12:10:28.046'!
addChild: newRoot at: position
	(position < 1 or: position > maxChildren) ifTrue: [
		self error: 'position out of bounds'.].
	newRoot parent ifNotNil: [self error: 'node already has a parent'.].

	[children size < position] whileTrue: [
		children add: nil].

	(children at: position) ifNil: [
		children at: position put: newRoot.
		newRoot parent: self.
		self addedChild: newRoot to: self at: position.
		numChildren := numChildren+1.] ifNotNil: [
		self error: 'child already present.'
		].! !

!I2STreeNode methodsFor: 'signals' stamp: 'benjamin.siegmund 6/12/2013 15:16:50.542'!
addedChild: newRoot to: parent at: position
self silent ifFalse:[
	self parent ifNil: [
		self emitAlways.
	] ifNotNil: [
		self parent addedChild: newRoot to: parent at: position
	].
].! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 15:16:17.093'!
beNotSilent
	self silent: false.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 15:16:00.949'!
beSilent
	self silent: true.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/2/2013 15:41:07.532'!
children

^children! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:06:57.034'!
color

	^color! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:06:13.238'!
color: aColor
	
	color := aColor.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 12:38:13.762'!
getChildAt: position
	(position < 1 or: position > maxChildren) ifTrue: [
		self error: 'position out of bounds'.].

	children size >= position ifTrue: [
		^children at: position] ifFalse: [
		^nil]! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/29/2013 16:47:52.104'!
getValueAt: position
	(position < 1 or: position > maxValues) ifTrue: [
		self error: 'position out of bounds'].

	(values size >= position) ifTrue: [
		^values at: position] ifFalse:[
		^nil]! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/2/2013 15:41:24.062'!
hasChildren

^numChildren > 0! !

!I2STreeNode methodsFor: 'initialize-release' stamp: 'benjamin.siegmund 6/12/2013 15:23:17.712'!
initialize
	silent := false.
	parent := nil.
	children := OrderedCollection new.
	values := OrderedCollection new.
	numChildren := 0.
	maxChildren := 10.
	maxValues := 9.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/29/2013 16:46:35.244'!
maxChildren

	^maxChildren! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 11:56:18.137'!
maxChildren: aNumber

	maxChildren := aNumber.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/29/2013 16:46:37.916'!
maxValues

	^maxValues! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 11:55:05.223'!
maxValues: aNumber

	maxValues := aNumber.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/2/2013 15:41:30.94'!
numChildren

^numChildren! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/29/2013 16:46:40.214'!
parent

	^parent! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 14:02:41.641'!
parent: aNode

	parent := aNode.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'sebastian.stamm 6/12/2013 12:03:52.143'!
removeChildAt: position
(position < 1 or: position > maxChildren) ifTrue: [
		self error: 'position out of bounds'.].
	
children size >= position ifTrue: [
	(children at: position) ifNotNil:[
		| child |
		child := children at: position.
		children at: position put: nil.
		child parent: nil.
		self removedChild: child from: self at: position.
		numChildren := numChildren-1.]]! !

!I2STreeNode methodsFor: 'signals' stamp: 'benjamin.siegmund 6/12/2013 15:17:13.817'!
removedChild: root from: parent at: position
self silent ifFalse:[
	self parent ifNil: [
		self emitAlways.
	] ifNotNil: [
		self parent removedChild: root from: parent at: position
	].
].! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 16:27:04.935'!
replace: child with: newChild
	1 to: children size do: [ :i |
		((self children	at: i) = child) ifTrue: [
			self removeChildAt: i.
			self addChild: newChild at: i.
		] 
	]! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 11:53:59.231'!
setValue: aValue at: position
	(position < 1 or: position > maxValues) ifTrue: [
		self error: 'position out of bounds'.].

	[values size < position] whileTrue: [
		values add: nil].

	values at: position put: aValue.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 15:14:43.224'!
silent
	^silent.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 15:15:11.912'!
silent: aBoolean
	silent := aBoolean.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 17:37:22.205'!
visualization: aVisualNode

	visualization := aVisualNode.! !

Object subclass: #I2SUserCode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SUserCode methodsFor: 'userMethods' stamp: 'dg 6/12/2013 16:17:11.556'!
findValue: aValue
self goLeft.
(self value = aValue) ifTrue: [ Transcript showln: 'Success!!']
ifFalse: [ Transcript showln: 'Fail :('].! !

!I2SUserCode methodsFor: 'as yet unclassified' stamp: 'dg 6/12/2013 16:17:08.497'!
goLeft 

	Transcript showln: 'goLeft is not implemented'! !

CircleMorph subclass: #I2SVisualNode
	instanceVariableNames: 'node parentEdge childEdges visualization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 15:25:40.439'!
blankNodeWidth
	^40! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 15:26:38.883'!
defaultAnimationDuration

	^ 400! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:10:59.158'!
defaultNodeColor

	^Color orange ! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 12:19:35.238'!
levelHeight
	^20! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 14:31:07.786'!
newWithNode: aNode on: aVisualization
	| a |
	a := self new.
	a node: aNode.
	a visualization: aVisualization.
	a visualization setVisualNode: a for: aNode.
	
	a draw.	
	aNode hasChildren ifTrue: [
		a drawChildren.
	].
	a setupEventListeners.
	
	^a! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:12:19.625'!
newWithNode: aNode renderDepth: aNumber on: aVisualization
	| a |
	a := self new.
	a node: aNode.
	a visualization: aVisualization.
	a visualization setVisualNode: a for: aNode.
	
	a draw.
	((aNumber > 1) and: (aNode hasChildren)) ifTrue: [
		a drawChildrenWithDepth: aNumber. 
	].
	"a bounds: a fullBounds."
	a setupEventListeners.

	^a! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 15:26:55.253'!
nodeSpace

	^20! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 13:05:24.766'!
addChildEdge: anEdge

	childEdges add: anEdge.! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 15:59:41.022'!
arrangeChildren: children withOffset: offset
	| o |

	o := offset.

	children do: [:child |
		child isNil ifTrue: [
			o := o + self class blankNodeWidth + self class nodeSpace.
			childEdges add: nil.
		] 
		ifFalse: [
			|x y edge|
			"x := (offset + (child fullBounds width / 2))."
			x := (o + (0 - (child fullBounds topLeft x))).
			y := self class levelHeight + self bounds height.
			child position: x@y.
			o := o + child fullBounds width + self class nodeSpace.
			self addMorph: child.
			"the line"
			edge := (LineMorph 
					from: self bounds bottomCenter 
					to: child bounds topCenter
					color: Color black 
					width: 5).
			child parentEdge: edge.	
			self childEdges add: edge.
			self addMorph: edge.
		]
	].! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 17:20:13.994'!
calculateOffset: children
	| totalWidth l r b |

	"documented on https://rialgar.de/IRDA2013Doku/page.xhtml"

	totalWidth := self calculateTotalWidth: children.
	
	l := 0. r := 0. b := 0.
	
	(children first) ifNotNil: [
		l := 0 - ((children first) fullBounds left).
	].
	(children last)  ifNotNil:[
		r := ((children last fullBounds right) - (children last bounds right)).
	].
	b := self bounds width.
	
	^ 0 - ((totalWidth+l-r-b)/2).! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 17:04:50.051'!
calculateTotalWidth: children
	| totalWidth |
	totalWidth := 0.
	
	children do:[ :child |
			child isNil ifTrue: [
				totalWidth := totalWidth + self class blankNodeWidth.
			] ifFalse: [
				totalWidth := totalWidth + (child fullBounds width).
			].
		].
	
	"between childs there should be some space, so we add this to the total width"
	totalWidth := totalWidth + (((children size) - 1) * self class nodeSpace).
	
	^totalWidth! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 13:34:44.775'!
childEdges
	
	^ childEdges! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 18:12:57.559'!
draw
	(node color) ifNotNil:
		[self color: node color]
	ifNil:
		[self color: 
			self class defaultNodeColor].
	self drawValue.! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:02:51.694'!
drawChildren 
	self drawChildrenWithDepth: Float infinity.! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 17:27:17.271'!
drawChildrenWithDepth: aNumber 
	| children offset |
	children := self gatherChildrenWithDepth: aNumber.
	
	offset := self calculateOffset: children.
	
	self arrangeChildren: children withOffset: offset.
! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/29/2013 14:30:11.745'!
drawValue
	| textMorph |
	textMorph := TextMorph new.
	textMorph contents: (((self node getValueAt: 1) asString) truncateTo: 4).
	textMorph lock: true.
	self addMorph: textMorph.
	textMorph position: 10@10.! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 13:26:22.498'!
edges

	| allEdges |
	allEdges := OrderedCollection new.
	allEdges addAll: childEdges.
	parentEdge ifNotNil: [allEdges add: parentEdge].
	
	^ allEdges ! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 17:09:51.605'!
gatherChildrenWithDepth: aNumber
	| children |
	children := OrderedCollection new.
	
	(node children) 
		do: [ :child || a |
			child isNil 
			ifTrue: [
				children add: nil.
			] 
			ifFalse: [
				a := self class newWithNode: child renderDepth: (aNumber - 1) on: self visualization.
				children add: a.
			].
		].
	
	^children.
! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 13:09:36.702'!
initialize 
	
	super initialize.
	childEdges := OrderedCollection new.! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:44:50.635'!
node
 ^node! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:44:54.969'!
node: aNode
 node := aNode! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dg 5/30/2013 14:16:07.64'!
parentEdge

	^ parentEdge! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dg 5/30/2013 14:15:49.976'!
parentEdge: anEdge

	parentEdge := anEdge! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 16:04:25.825'!
position: aPoint

	super position: aPoint.
	parentEdge ifNotNil:[
		parentEdge setVertices: 
			{(parentEdge vertices at: 1 ). (self bounds topCenter) }.		
	].
	childEdges do: [ :edge |
		
		edge ifNotNil: [
		edge setVertices:
			{(self bounds bottomCenter). (edge vertices at: 2) }
			].
	].
	
	^self! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 18:54:57.496'!
setupEventListeners 
	"self on: #mouseEnter send: #onMouseEnter: to: self."
	self balloonText: (self node getValueAt: 1) asString."
	self addMorph: (BalloonMorph string: ((self node getValueAt: 1) asString) for: self corner: #topLeft)."! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 18:24:24.415'!
visualization 
	
	^visualization
	! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 18:24:45.659'!
visualization: aVisualization
	
	visualization := aVisualization.
	! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 15:25:33.661'!
walkToPosition: aPoint

	self walkToPosition: aPoint then: []! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 15:26:42.588'!
walkToPosition: aPoint then: aBlock

		(AnimPropertyAnimation
		on: self
		property: #position
		start: self position
		end: aPoint
		duration: self class defaultAnimationDuration)
		finishBlock: aBlock;
		register;
		start: #deleteWhenFinished.! !
